<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<xsl:template match="text()|@*">
</xsl:template>


<xsl:template match="USBSpyLog">
<html>
<title>USBSpy Log Report</title>
<body>
	<h2><center><b><u>USBSpyLog</u></b></center></h2><br/>
	<a href="#Devices">Devices Information</a><br/>
	<a href="#LogEntries">Log Entries</a><br/><br/>
	<b>Date: </b><xsl:value-of select="@Date"/><br/>
	<b>Time: </b><xsl:value-of select="@Time"/><br/>
	<b>Computer Name: </b><xsl:value-of select="@ComputerName"/><br/>
	<b>Windows Platform: </b><xsl:value-of select="@WindowsPlatform"/><br/>
	<b>Windows Version: </b><xsl:value-of select="@WindowsVersion"/><br/>
	<b>Windows Build Number: </b><xsl:value-of select="@WindowsBuildNumber"/><br/>
	<b>Number of CPU's: </b><xsl:value-of select="@NumberOfCPUs"/><br/>
	<br/><br/><hr/>
	<xsl:apply-templates/>
</body>
</html>
</xsl:template>

<xsl:template match="Devices">
	<a name="Devices"/>
	<center><h2><b><u>Devices Information</u></b></h2></center>
	<xsl:apply-templates/>
	<br/><br/><br/><br/>
</xsl:template>

<xsl:template match="Devices/Device">
	<h3><bold><u><xsl:value-of select="@Name"/></u></bold></h3><br/>
	<xsl:apply-templates/>
	<hr/>
</xsl:template>

<xsl:template match="Device/DeviceStack">
	<b>DeviceObject Stack</b><br/>
	<table border="1">
		<tr><td><b>Device Name</b></td><td><b>Device Object</b></td><td><b>Service</b></td></tr>
	<xsl:apply-templates/>
	</table><br/>
</xsl:template>

<xsl:template match="Device/DeviceStack/DeviceStackEntry">
		<tr><td><xsl:value-of select="@DeviceObjectName"/></td><td><xsl:value-of select="@DeviceObjectAddress"/></td><td><xsl:value-of select="@DriverName"/></td></tr>
</xsl:template>

<xsl:template match="Device/Properties">
	<b><xsl:value-of select="@Type"/> Properties</b><br/>
	<table border="1">
		<tr><td>Description</td><td><xsl:value-of select="Description"/></td></tr>
		<tr><td>Setup Class</td><td><xsl:value-of select="SetupClass"/></td></tr>
		<tr><td>Class GUID</td><td><xsl:value-of select="ClassGUID"/></td></tr>
		<tr><td>Enumerator</td><td><xsl:value-of select="Enumerator"/></td></tr>
		<tr><td>HardwareID</td><td><xsl:value-of select="HardwareID"/></td></tr>
		<tr><td>Symbolic Link</td><td><xsl:value-of select="SymbolicLink"/></td></tr>
		<tr><td>DeviceObject</td><td><xsl:value-of select="DeviceName"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/DeviceInterfaces">
	<b>Device Interfaces</b><br/>
	<table border="1">
		<xsl:apply-templates/>
	</table><br/>
</xsl:template>

<xsl:template match="Device/DeviceInterfaces/DeviceInterface">
	<tr><td><b>Interface</b></td></tr>
	<tr><td>Interface GUID</td><td><xsl:value-of select="InterfaceGUID"/></td></tr>
	<tr><td>Symbolic Link</td><td><xsl:value-of select="SymbolicLink"/></td></tr>
</xsl:template>

<xsl:template match="Device/HubInformation">
	<b>Hub Information (HubIsBusPowered: <xsl:value-of select="HubIsBusPowered"/>)</b><br/>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="Device/HubInformation/HubDescriptor">
	<table border="1">
		<tr><td><b>Hub Descriptor</b></td></tr>
		<tr><td>bDescriptorLength</td><td><xsl:value-of select="bDescriptorLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bNumberOfPorts</td><td><xsl:value-of select="bNumberOfPorts"/></td></tr>
		<tr><td>wHubCharacteristics</td><td><xsl:value-of select="wHubCharacteristics"/></td></tr>
		<tr><td>bPowerOnToPowerGood</td><td><xsl:value-of select="bPowerOnToPowerGood"/></td></tr>
		<tr><td>bHubControlCurrent</td><td><xsl:value-of select="bHubControlCurrent"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/DeviceDescriptor">
	<b>Device Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bcdUSB</td><td><xsl:value-of select="bcdUSB"/></td></tr>
		<tr><td>bDeviceClass</td><td><xsl:value-of select="bDeviceClass"/></td></tr>
		<tr><td>bDeviceSubClass</td><td><xsl:value-of select="bDeviceSubClass"/></td></tr>
		<tr><td>bDeviceProtocol</td><td><xsl:value-of select="bDeviceProtocol"/></td></tr>
		<tr><td>bMaxPacketSize0</td><td><xsl:value-of select="bMaxPacketSize0"/></td></tr>
		<tr><td>idVendor</td><td><xsl:value-of select="idVendor"/></td></tr>
		<tr><td>idProduct</td><td><xsl:value-of select="idProduct"/></td></tr>
		<tr><td>bcdDevice</td><td><xsl:value-of select="bcdDevice"/></td></tr>
		<tr><td>iManufacturer</td><td><xsl:value-of select="iManufacturer"/></td></tr>
		<tr><td>iProduct</td><td><xsl:value-of select="iProduct"/></td></tr>
		<tr><td>iSerialNumber</td><td><xsl:value-of select="iSerialNumber"/></td></tr>
		<tr><td>bNumConfigurations</td><td><xsl:value-of select="bNumConfigurations"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/ConfigurationDescriptor">
	<b>Configuration Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>wTotalLength</td><td><xsl:value-of select="wTotalLength"/></td></tr>
		<tr><td>bNumInterfaces</td><td><xsl:value-of select="bNumInterfaces"/></td></tr>
		<tr><td>bConfigurationValue</td><td><xsl:value-of select="bConfigurationValue"/></td></tr>
		<tr><td>iConfiguration</td><td><xsl:value-of select="iConfiguration"/></td></tr>
		<tr><td>bmAttributes</td><td><xsl:value-of select="bmAttributes"/></td></tr>
		<tr><td>MaxPower</td><td><xsl:value-of select="MaxPower"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/InterfaceDescriptor">
	<b>Interface Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bInterfaceNumber</td><td><xsl:value-of select="bInterfaceNumber"/></td></tr>
		<tr><td>bAlternateSetting</td><td><xsl:value-of select="bAlternateSetting"/></td></tr>
		<tr><td>bNumEndpoints</td><td><xsl:value-of select="bNumEndpoints"/></td></tr>
		<tr><td>bInterfaceClass</td><td><xsl:value-of select="bInterfaceClass"/></td></tr>
		<tr><td>bInterfaceSubclass</td><td><xsl:value-of select="bInterfaceSubclass"/></td></tr>
		<tr><td>bInterfaceProtocol</td><td><xsl:value-of select="bInterfaceProtocol"/></td></tr>
		<tr><td>iInterface</td><td><xsl:value-of select="iInterface"/></td></tr>
		<tr><td>wNumClasses</td><td><xsl:value-of select="wNumClasses"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/EndpointDescriptor">
	<b>Endpoint Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bEndpointAddress</td><td><xsl:value-of select="bEndpointAddress"/></td></tr>
		<tr><td>bmAttributes</td><td><xsl:value-of select="bmAttributes"/></td></tr>
		<tr><td>wMaxPacketSize</td><td><xsl:value-of select="wMaxPacketSize"/></td></tr>
		<tr><td>bInterval</td><td><xsl:value-of select="bInterval"/></td></tr>
		<tr><td>WInterval</td><td><xsl:value-of select="wInterval"/></td></tr>
		<tr><td>bSyncAddress</td><td><xsl:value-of select="bSyncAddress"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/HidDescriptor">
	<b>HID Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bcdHID</td><td><xsl:value-of select="bcdHID"/></td></tr>
		<tr><td>bCountryCode</td><td><xsl:value-of select="bCountryCode"/></td></tr>
		<tr><td>bNumDescriptors</td><td><xsl:value-of select="bNumDescriptors"/></td></tr>
	<xsl:apply-templates/>
	</table><br/>
</xsl:template>

<xsl:template match="Device/HidDescriptor/OptionalDescriptors/OptionalDescriptor">
		<tr><td><b>OptionalDescriptor</b></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>wDescriptorLength</td><td><xsl:value-of select="wDescriptorLength"/></td></tr>
</xsl:template>

<xsl:template match="Device/DeviceQualifierDescriptor">
	<b>Device Qualifier Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bcdUSB</td><td><xsl:value-of select="bcdUSB"/></td></tr>
		<tr><td>bDeviceClass</td><td><xsl:value-of select="bDeviceClass"/></td></tr>
		<tr><td>bDeviceSubclass</td><td><xsl:value-of select="bDeviceSubclass"/></td></tr>
		<tr><td>bDeviceProtocol</td><td><xsl:value-of select="bDeviceProtocol"/></td></tr>
		<tr><td>bMaxPacketSize</td><td><xsl:value-of select="bMaxPacketSize"/></td></tr>
		<tr><td>bNumConfiguration</td><td><xsl:value-of select="bNumConfiguration"/></td></tr>
		<tr><td>Reserved</td><td><xsl:value-of select="Reserved"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/InterfacePowerDescriptor">
	<b>Interface Power Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bmCapabilitiesFlags</td><td><xsl:value-of select="bmCapabilitiesFlags"/></td></tr>
		<tr><td>bBusPowerSavingD1</td><td><xsl:value-of select="bBusPowerSavingD1"/></td></tr>
		<tr><td>bSelfPowerSavingD1</td><td><xsl:value-of select="bSelfPowerSavingD1"/></td></tr>
		<tr><td>bBusPowerSavingD2</td><td><xsl:value-of select="bBusPowerSavingD2"/></td></tr>
		<tr><td>bSelfPowerSavingD2</td><td><xsl:value-of select="bSelfPowerSavingD2"/></td></tr>
		<tr><td>bBusPowerSavingD3</td><td><xsl:value-of select="bBusPowerSavingD3"/></td></tr>
		<tr><td>bSelfPowerSavingD3</td><td><xsl:value-of select="bSelfPowerSavingD3"/></td></tr>
		<tr><td>TransitionTimeFromD1</td><td><xsl:value-of select="TransitionTimeFromD1"/></td></tr>
		<tr><td>TransitionTimeFromD2</td><td><xsl:value-of select="TransitionTimeFromD2"/></td></tr>
		<tr><td>TransitionTimeFromD3</td><td><xsl:value-of select="TransitionTimeFromD3"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/ConfigPowerDescriptor">
	<b>ConfigPower Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>SelfPowerConsumedD0</td><td><xsl:value-of select="SelfPowerConsumedD0"/></td></tr>
		<tr><td>bPowerSummaryId</td><td><xsl:value-of select="bPowerSummaryId"/></td></tr>
		<tr><td>bBusPowerSavingD1</td><td><xsl:value-of select="bBusPowerSavingD1"/></td></tr>
		<tr><td>bSelfPowerSavingD1</td><td><xsl:value-of select="bSelfPowerSavingD1"/></td></tr>
		<tr><td>bBusPowerSavingD2</td><td><xsl:value-of select="bBusPowerSavingD2"/></td></tr>
		<tr><td>bSelfPowerSavingD2</td><td><xsl:value-of select="bSelfPowerSavingD2"/></td></tr>
		<tr><td>bBusPowerSavingD3</td><td><xsl:value-of select="bBusPowerSavingD3"/></td></tr>
		<tr><td>bSelfPowerSavingD3</td><td><xsl:value-of select="bSelfPowerSavingD3"/></td></tr>
		<tr><td>TransitionTimeFromD1</td><td><xsl:value-of select="TransitionTimeFromD1"/></td></tr>
		<tr><td>TransitionTimeFromD2</td><td><xsl:value-of select="TransitionTimeFromD2"/></td></tr>
		<tr><td>TransitionTimeFromD3</td><td><xsl:value-of select="TransitionTimeFromD3"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/UnknownDescriptor">
	<b>Unknown Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>Data</td><td><xsl:value-of select="Data"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlInterfaceHeaderDescriptor">
	<b>Audio Control Interface Header Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bcdADC</td><td><xsl:value-of select="bcdADC"/></td></tr>
		<tr><td>wTotalLength</td><td><xsl:value-of select="wTotalLength"/></td></tr>
		<tr><td>bInCollection</td><td><xsl:value-of select="bInCollection"/></td></tr>
		<tr><td>baInterfaceNr</td><td><xsl:value-of select="baInterfaceNr"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlInputTerminalDescriptor">
	<b>Audio Control Input Terminal Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bTerminalID</td><td><xsl:value-of select="bTerminalID"/></td></tr>
		<tr><td>wTerminalType</td><td><xsl:value-of select="wTerminalType"/></td></tr>
		<tr><td>bAssocTerminal</td><td><xsl:value-of select="bAssocTerminal"/></td></tr>
		<tr><td>bNrChannels</td><td><xsl:value-of select="bNrChannels"/></td></tr>
		<tr><td>wChannelsConfig</td><td><xsl:value-of select="wChannelsConfig"/></td></tr>
		<tr><td>iChannelNames</td><td><xsl:value-of select="iChannelNames"/></td></tr>
		<tr><td>iTerminal</td><td><xsl:value-of select="iTerminal"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlOutputTerminalDescriptor">
	<b>Audio Control Output Terminal Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bTerminalID</td><td><xsl:value-of select="bTerminalID"/></td></tr>
		<tr><td>wTerminalType</td><td><xsl:value-of select="wTerminalType"/></td></tr>
		<tr><td>bAssocTerminal</td><td><xsl:value-of select="bAssocTerminal"/></td></tr>
		<tr><td>bSoruceID</td><td><xsl:value-of select="bSoruceID"/></td></tr>
		<tr><td>iTerminal</td><td><xsl:value-of select="iTerminal"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlMixerUnitDescriptor">
	<b>Audio Control Mixer Unit Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bUnitID</td><td><xsl:value-of select="bUnitID"/></td></tr>
		<tr><td>bNrInPins</td><td><xsl:value-of select="bNrInPins"/></td></tr>
		<tr><td>bAssocTerminal</td><td><xsl:value-of select="bAssocTerminal"/></td></tr>
		<tr><td>bSoruceID</td><td><xsl:value-of select="bSoruceID"/></td></tr>
		<tr><td>iTerminal</td><td><xsl:value-of select="iTerminal"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlMixerUnitDescriptor">
	<b>Audio Control Mixer Unit Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bUnitID</td><td><xsl:value-of select="bUnitID"/></td></tr>
		<tr><td>bNrInPins</td><td><xsl:value-of select="bNrInPins"/></td></tr>
		<tr><td>baSourceID</td><td><xsl:value-of select="baSourceID"/></td></tr>
		<tr><td>bNrChannels</td><td><xsl:value-of select="bNrChannels"/></td></tr>
		<tr><td>wChannelsConfig</td><td><xsl:value-of select="wChannelsConfig"/></td></tr>
		<tr><td>iChannelNames</td><td><xsl:value-of select="iChannelNames"/></td></tr>
		<tr><td>bmControls</td><td><xsl:value-of select="bmControls"/></td></tr>
		<tr><td>iMixer</td><td><xsl:value-of select="iMixer"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlSelectorUnitDescriptor">
	<b>Audio Control Selector Uni tDescriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bUnitID</td><td><xsl:value-of select="bUnitID"/></td></tr>
		<tr><td>bNrInPins</td><td><xsl:value-of select="bNrInPins"/></td></tr>
		<tr><td>baSourceID</td><td><xsl:value-of select="baSourceID"/></td></tr>
		<tr><td>iSelector</td><td><xsl:value-of select="iSelector"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlFeatureUnitDescriptor">
	<b>Audio Control Feature Unit Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bUnitID</td><td><xsl:value-of select="bUnitID"/></td></tr>
		<tr><td>baSourceID</td><td><xsl:value-of select="baSourceID"/></td></tr>
		<tr><td>bControlSize</td><td><xsl:value-of select="bControlSize"/></td></tr>
		<tr><td>iFeature</td><td><xsl:value-of select="iFeature"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlProcessingUnitDescriptor">
	<b>Audio Control Processing Unit Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bUnitID</td><td><xsl:value-of select="bUnitID"/></td></tr>
		<tr><td>wProcessType</td><td><xsl:value-of select="wProcessType"/></td></tr>
		<tr><td>bNrInPins</td><td><xsl:value-of select="bNrInPins"/></td></tr>
		<tr><td>baSourceID</td><td><xsl:value-of select="baSourceID"/></td></tr>
		<tr><td>bNrChannels</td><td><xsl:value-of select="bNrChannels"/></td></tr>
		<tr><td>wChannelsConfig</td><td><xsl:value-of select="wChannelsConfig"/></td></tr>
		<tr><td>iChannelNames</td><td><xsl:value-of select="iChannelNames"/></td></tr>
		<tr><td>bControlSize</td><td><xsl:value-of select="bControlSize"/></td></tr>
		<tr><td>bmControls</td><td><xsl:value-of select="bmControls"/></td></tr>
		<tr><td>iProcessing</td><td><xsl:value-of select="iProcessing"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioControlExtensionUnitDescriptor">
	<b>Audio Control Extension Unit Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bUnitID</td><td><xsl:value-of select="bUnitID"/></td></tr>
		<tr><td>wExtensionCode</td><td><xsl:value-of select="wExtensionCode"/></td></tr>
		<tr><td>bNrInPins</td><td><xsl:value-of select="bNrInPins"/></td></tr>
		<tr><td>baSourceID</td><td><xsl:value-of select="baSourceID"/></td></tr>
		<tr><td>bNrChannels</td><td><xsl:value-of select="bNrChannels"/></td></tr>
		<tr><td>wChannelsConfig</td><td><xsl:value-of select="wChannelsConfig"/></td></tr>
		<tr><td>iChannelNames</td><td><xsl:value-of select="iChannelNames"/></td></tr>
		<tr><td>bControlSize</td><td><xsl:value-of select="bControlSize"/></td></tr>
		<tr><td>bmControls</td><td><xsl:value-of select="bmControls"/></td></tr>
		<tr><td>iExtension</td><td><xsl:value-of select="iExtension"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioStreamingClassSpecificInterfaceDescriptor">
	<b>Audio Streaming Class Specific Interface Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bTerminalLink</td><td><xsl:value-of select="bTerminalLink"/></td></tr>
		<tr><td>bDelay</td><td><xsl:value-of select="bDelay"/></td></tr>
		<tr><td>wFormatTag</td><td><xsl:value-of select="wFormatTag"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioStreamingClassSpecificAudioDataEndpointDescriptor">
	<b>Audio Streaming Class Specific Audio Data Endpoint Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bmAttributes</td><td><xsl:value-of select="bmAttributes"/></td></tr>
		<tr><td>bLockDelayUnits</td><td><xsl:value-of select="bLockDelayUnits"/></td></tr>
		<tr><td>wLockDelay</td><td><xsl:value-of select="wLockDelay"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioStreamingFormatTypeDescriptor">
	<b>Audio Streaming Format Type Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
		<tr><td>bFormatType</td><td><xsl:value-of select="bFormatType"/></td></tr>
		<tr><td>bNrChannels</td><td><xsl:value-of select="bNrChannels"/></td></tr>
		<tr><td>bSubframeSize</td><td><xsl:value-of select="bSubframeSize"/></td></tr>
		<tr><td>bBitResolution</td><td><xsl:value-of select="bBitResolution"/></td></tr>
		<tr><td>bSamFreqType</td><td><xsl:value-of select="bSamFreqType"/></td></tr>
		<tr><td>wMaxBitRate</td><td><xsl:value-of select="wMaxBitRate"/></td></tr>
		<tr><td>wSamplesPerFrame</td><td><xsl:value-of select="wSamplesPerFrame"/></td></tr>
	</table><br/>
</xsl:template>

<xsl:template match="Device/AudioStreamingFormatSpecificDescriptor">
	<b>Audio Streaming Format Specific Descriptor</b>
	<table border="1">
		<tr><td>bLength</td><td><xsl:value-of select="bLength"/></td></tr>
		<tr><td>bDescriptorType</td><td><xsl:value-of select="bDescriptorType"/></td></tr>
		<tr><td>bDescriptorSubtype</td><td><xsl:value-of select="bDescriptorSubtype"/></td></tr>
	</table><br/>
</xsl:template>


<xsl:template match="LogEntries">
	<a name="LogEntries"/>
	<center><h2><b><u>Log Entries</u></b></h2></center>
	<table border="1">
	<tr>
		<td><b>Type</b></td>
		<td><b>Request</b></td>
		<td><b>I/O</b></td>
		<td><b>Elapsed Seconds</b></td>
		<td><b>DeviceObject</b></td>
		<td><b>IRP Request</b></td>
		<td><b>IRP Status</b></td>
		<td><b>Process Name</b></td>
	</tr>
	<xsl:apply-templates/>
	</table>
</xsl:template>

<xsl:template match="LogEntries/entry[@StartEnd='Start']">
	<tr>
		<td><xsl:value-of select="@Type"/></td>
		<td><xsl:value-of select="@Request"/></td>
		<td><xsl:value-of select="@IO"/></td>
		<td><xsl:value-of select="@ElapsedSeconds"/></td>
		<td><xsl:value-of select="@DeviceObjectName"/> (0x<xsl:value-of select="@DeviceObject"/>)</td>
		<td><xsl:value-of select="@Irp"/></td>
		<td><xsl:value-of select="@Status"/></td>
		<td><xsl:value-of select="@Process"/></td>
	</tr>
</xsl:template>

<xsl:template match="LogEntries/entry[@StartEnd='End']">
	<tr bgcolor="#CFCFCF">
		<td><xsl:value-of select="@Type"/></td>
		<td><xsl:value-of select="@Request"/></td>
		<td><xsl:value-of select="@IO"/></td>
		<td><xsl:value-of select="@ElapsedSeconds"/></td>
		<td><xsl:value-of select="@DeviceObjectName"/> (0x<xsl:value-of select="@DeviceObject"/>)</td>
		<td><xsl:value-of select="@Irp"/></td>
		<td><xsl:value-of select="@Status"/></td>
		<td><xsl:value-of select="@Process"/></td>
	</tr>
</xsl:template>


</xsl:stylesheet>